if UnitClass("player") == "Monk" then
local tptime = 0
local btaura, btcd, btCD, bttime, btcount = 0, 0, 0, 0, 0, 0, 0 --  Tracker variables
local tier2 = 0
-- The sounds used in this addon are not my own and were obtained from the following websites:
-- www.soundfxcenter.com
-- www.soundjax.com
-- www.kyutwo.com
local stime = 0
local pdur, pguid, pname, pculprit, papplied, ptime, pexpired, pbreak, pmarg2, pmarg13, pmdelay = 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
local trigger = 0
local regen = true
local delay = 0.1
local fsknorepeat = 0
local tftdelay = 0.1
local death = false
local fatalitydelay, fatalitynorepeat = 0, 0


function MonkHelper_ShuffleTimer(self, elapsed)
stime = stime - elapsed
stext:SetTextColor(1, 1, 1)
if stime <= 0 then
stime = 0
MHstimer:Hide()
stext:SetText()
sicon:SetVertexColor(1, 0, 0)
elseif stime <= 5 then
stext:SetTextColor(1, 0, 0)
stext:SetText(string.sub(stime, 1, 4))
if stime <= 5 and stime > 4.5 then
sicon:SetVertexColor(1, 0, 0)
end
if stime <= 4.5 and stime > 4 then
sicon:SetVertexColor(1, 1, 1)
end
if stime <= 4 and stime > 3.5 then
sicon:SetVertexColor(1, 0, 0)
end
if stime <= 3.5 and stime > 3 then
sicon:SetVertexColor(1, 1, 1)
end
if stime <= 3 and stime > 2.5 then
sicon:SetVertexColor(1, 0, 0)
end
if stime <= 2.5 and stime > 2 then
sicon:SetVertexColor(1, 1, 1)
end
if stime <= 2 and stime > 1.5 then
sicon:SetVertexColor(1, 0, 0)
end
if stime <= 1.5 and stime > 1 then
sicon:SetVertexColor(1, 1, 1)
end
if stime <= 1 and stime > 0.5 then
sicon:SetVertexColor(1, 0, 0)
end
if stime <= 0.5 and stime > 0 then
sicon:SetVertexColor(1, 1, 1)
end
else
stext:SetText(string.sub(stime, 1, 4))
end
end

function MonkHelper_FatalityTimer(self, elapsed)
fatalitydelay = fatalitydelay - elapsed
if fatalitydelay <= 1.7 and fatalitynorepeat == 0 then
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\fatalitybg.mp3", "Master")
fatalitynorepeat = 1
elseif fatalitydelay <= 0 then
fatalitydelay = 0
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\fatality.mp3", "Master")
MHfatalitytimer:Hide()
end
end

function MHFIX()
MHchibar.mainframe:ClearAllPoints() 
MHchibar.mainframe:SetPoint("CENTER", nil, "CENTER", -98.30, -27) 
MHresourcebar:ClearAllPoints() 
MHresourcebar:SetPoint("BOTTOMLEFT", MHchibar.mainframe, "TOPLEFT")
MHrisingsunkick:ClearAllPoints()
MHrisingsunkick:SetPoint("BOTTOMLEFT", MHresourcebar, "TOPLEFT", 0, 15)
MHtigerpower:ClearAllPoints()
MHtigerpower:SetPoint("LEFT", MHrisingsunkick, "RIGHT")
MHbrewtracker:ClearAllPoints()
MHbrewtracker:SetPoint("LEFT", MHtigerpower, "RIGHT")
MHexpelharm:ClearAllPoints()
MHexpelharm:SetPoint("BOTTOMLEFT", MHrisingsunkick, "TOPLEFT")
MHfistsoffury:ClearAllPoints()
MHfistsoffury:SetPoint("LEFT", MHexpelharm, "RIGHT")
MHtier2:ClearAllPoints()
MHtier2:SetPoint("LEFT", MHfistsoffury, "RIGHT")
MHparalysis:ClearAllPoints()
MHparalysis:SetPoint("BOTTOM", nil, "BOTTOM", -47.99, 143.59)
end

function MonkHelper_FSKTimer()
local start, cd = GetSpellCooldown("flying serpent kick")
CD = (start + cd) - GetTime()
if CD > 0 and fsknorepeat == 0 then
MHFSKCD:SetCooldown(GetTime(), CD)
fsknorepeat = 1
MHfsktimer:Hide()
end
end

function MonkHelper_PMDelay(self, elapsed)
pmdelay = pmdelay - elapsed
if pmdelay <= 0 then
MHpmdelay:Hide()
if papplied == 1 and pexpired == 1 and MonkHelper_Options.show.MHparalysis == 1 then
if MonkHelper_Options.pmnotify == 1 then
print("Paralysis on "..pname.." has expired.")
end
papplied = 0
pdur = 0
pexpired = 0
pbreak = 0
end
end
end

function MonkHelper_PMCombine(arg2, arg13)
if pexpired == 1 and pbreak == 1 and MonkHelper_Options.show.MHparalysis == 1 then
arg16 = "Paralysis"
if MonkHelper_Options.pmnotify == 1 then
if UnitIsPlayer(pculprit) == 1 then
local class, file = UnitClass(pculprit)
local color = RAID_CLASS_COLORS[file]
if arg2 == "SPELL_DAMAGE" then
print(arg16.." was broken by ".."|c"..color.colorStr..pculprit.."|r".." via "..arg13..".")
elseif arg2 == "SPELL_PERIODIC_DAMAGE" then
print(arg16.." was broken by ".."|c"..color.colorStr..pculprit.."|r".." via "..arg13..". (Periodic)")
elseif arg2 == "SWING_DAMAGE" then
print(arg16.." was broken by ".."|c"..color.colorStr..pculprit.."|r".." via Melee Swing")
elseif arg2 == "RANGE_DAMAGE" then
print(arg16.." was broken by ".."|c"..color.colorStr..pculprit.."|r".." via Auto-Shoot")
end
else
if arg2 == "SPELL_DAMAGE" then
print(arg16.." was broken by "..pculprit.." via "..arg13..".")
elseif arg2 == "SPELL_PERIODIC_DAMAGE" then
print(arg16.." was broken by "..pculprit.." via "..arg13..". (Periodic)")
elseif arg2 == "SWING_DAMAGE" then
print(arg16.." was broken by "..pculprit.." via Melee Swing")
end
end
end
papplied = 0
pdur = 0
pexpired = 0
pbreak = 0
MHpmdelay:Hide()
end
end

function MonkHelper_Delay(self, elapsed)
delay = delay - elapsed
local CD = 0
local start, cd = GetSpellCooldown(trigger)
CD = (start + cd) - GetTime()
if delay <= 0 then
MHdelay:Hide()
if trigger == "Rising Sun Kick" then
MHRSKCD:SetCooldown(GetTime(), CD)
elseif trigger == "Keg Smash" then
MHKSCD:SetCooldown(GetTime(), CD)
elseif trigger == "Renewing Mist" then
MHRMCD:SetCooldown(GetTime(), CD)
elseif trigger == "Fists of Fury" then
MHFOFCD:SetCooldown(GetTime(), CD)
elseif trigger == "Guard" then
MHGCD:SetCooldown(GetTime(), CD)
elseif trigger == "Detox" then
MHDCD:SetCooldown(GetTime(), CD)
detoxdelay = 0.5
MHdetoxcheck:Show()
elseif trigger == "Expel Harm" then
MHEHCD:SetCooldown(GetTime(), CD)
elseif trigger == tier2 then
MHT2CD:SetCooldown(GetTime(), CD)
elseif trigger == "Paralysis" then
MHPCD:SetCooldown(GetTime(), CD)
if papplied == 1 then
local tdum1, tdum2, tdum3, tdum4, tdum5, tdur, texptime, tunitcaster = UnitDebuff("target", "paralysis")
local fdum1, fdum2, fdum3, fdum4, fdum5, fdur, fexptime, funitcaster = UnitDebuff("focus", "paralysis")
local mdum1, mdum2, mdum3, mdum4, mdum5, mdur, mexptime, munitcaster = UnitDebuff("mouseover", "paralysis")
local dur, exptime, unitcaster = 0, 0, 0
if texptime == nil and fexptime == nil and mexptime == nil then
exptime = 0
elseif texptime ~= nil then
exptime = texptime
dur = tdur
unitcaster = tunitcaster
elseif fexptime ~= nil then
exptime = fexptime
dur = fdur
unitcaster = funitcaster
elseif mexptime ~= nil then
exptime = mexptime
dur = mdur
unitcaster = munitcaster
end
if unitcaster == "player" and exptime > 0 then
pdur = exptime - GetTime()
MHpmonitor:Show()
MHpmonitorbg:Show()
MHpmonitor:SetMinMaxValues(0, dur)
MHpduration:Show()
pmntext:SetText(pname)
end
end
end
end
end

function MonkHelper_DetoxCheck(self, elapsed)
detoxdelay = detoxdelay - elapsed
local CD = 0
local start, cd = GetSpellCooldown("Detox")
if start == 0 or nil then
MHDCD:SetCooldown(0, 0)
end
if detoxdelay <= 0 then
MHdetoxcheck:Hide()
end
end

function MonkHelper_TFTDelay(self, elapsed)
tftdelay = tftdelay - elapsed
local CD = 0
if tftdelay <= 0 then
local start, cd = GetSpellCooldown("Thunder Focus Tea")
CD = (start + cd) - GetTime()
MHTFTCD:SetCooldown(GetTime(), CD)
MHtftdelay:Hide()
end
end

function MonkHelper_PDuration(self, elapsed)
pdur = pdur - elapsed
if pdur > 0 then
MonkHelper_Show(MHparalysis, MonkHelper_Options.show.MHparalysis)
end
if pdur <= 0 then
pdur = 0
MHpmonitor:SetValue(0)
pmtext:SetText()
pmntext:SetText()
MHpmonitor:Hide()
MHpmonitorbg:Hide()
MHpduration:Hide()
if MonkHelper_Options.pmautohide == 1 then
MHparalysis:Hide()
elseif MonkHelper_Options.pmautohide == 0 then
MHparalysis:Show()
end
elseif pdur <=5 then
pmtext:SetTextColor(1, 0, 0)
pmtext:SetText(string.sub(pdur, 1, 4))
MHpmonitor:SetValue(pdur)
else
MHpmonitor:SetValue(pdur)
pmtext:SetText(string.sub(pdur, 1, 4))
pmtext:SetTextColor(1, 1, 1)
end
end

function MonkHelper_ResourceBarUpdate() 
MHresourcebar:SetValue(UnitPower("player"))
rbtext:SetText(UnitPower("player"))
end

function MonkHelper_ChiBarUpdate()
local curchi = UnitPower("player", 12)
local maxchi = UnitPowerMax("player", 12)
local idx = 1
if maxchi == 4 then
MHchibar.texture0[5]:Hide()
MHchibar.texture1[5]:Hide()
MHchibar.chibubble[1]:SetPoint("TOPLEFT", MHchibar.mainframe, "TOPLEFT", 0, 0)
else
MHchibar.texture0[5]:Show()
MHchibar.chibubble[1]:SetPoint("TOPLEFT", MHchibar.mainframe, "TOPLEFT", -12, 0)
end
for idx = 1, curchi do
MHchibar.texture1[idx]:Show()
end
for idx = (UnitPower("player", 12)+1), maxchi do
MHchibar.texture1[idx]:Hide()
end
end

function MonkHelper_BTDelay(self, elapsed)
btdelay = btdelay - elapsed
if btdelay <= 0 then
btdelay = 0
MHbtdelay:Hide()
local start, tempbtcd = GetSpellCooldown(btaura)
if tempbtcd > 1 then
btcd = (start + tempbtcd) - GetTime()
MHBTCD:SetCooldown(GetTime(), btcd)
end
end
end

function MonkHelper_BTTimer(self, elapsed)
bttime = bttime - elapsed
bttext:SetTextColor(1, 1, 1)
if bttime <= 0 then
MHbttimer:Hide()
bttime = 0
btcount = 0
btctext:SetText()
bttext:SetText()
bticon:SetVertexColor(1, 0, 0)
elseif bttime <= 5 then
bttext:SetTextColor(1, 0, 0)
bttext:SetText(string.sub(bttime, 1, 4))
if bttime <= 5 and bttime > 4.5 then
bticon:SetVertexColor(1, 0, 0)
end
if bttime <= 4.5 and bttime > 4 then
bticon:SetVertexColor(1, 1, 1)
end
if bttime <= 4 and bttime > 3.5 then
bticon:SetVertexColor(1, 0, 0)
end
if bttime <= 3.5 and bttime > 3 then
bticon:SetVertexColor(1, 1, 1)
end
if bttime <= 3 and bttime > 2.5 then
bticon:SetVertexColor(1, 0, 0)
end
if bttime <= 2.5 and bttime > 2 then
bticon:SetVertexColor(1, 1, 1)
end
if bttime <= 2 and bttime > 1.5 then
bticon:SetVertexColor(1, 0, 0)
end
if bttime <= 1.5 and bttime > 1 then
bticon:SetVertexColor(1, 1, 1)
end
if bttime <= 1 and bttime > 0.5 then
bticon:SetVertexColor(1, 0, 0)
end
if bttime <= 0.5 and bttime > 0 then
bticon:SetVertexColor(1, 1, 1)
end
elseif bttime >= 60 then
bttext:SetTextColor(1, 0.85, 0)
bttext:SetText(SecondsToTime(bttime, true))
elseif bttime > 0 then
bttext:SetText(string.sub(bttime, 1, 4))
end
end

function MonkHelper_TPTimer(self, elapsed)
tptime = tptime - elapsed
tptext:SetTextColor(1, 1, 1)
if tptime <= 0 then
tptime = 0
MHtptimer:Hide()
tptext:SetText()
tpicon:SetVertexColor(1, 0, 0)
elseif tptime <= 5 then
tptext:SetTextColor(1, 0, 0)
tptext:SetText(string.sub(tptime, 1, 4))
if tptime <= 5 and tptime > 4.5 then
tpicon:SetVertexColor(1, 0, 0)
end
if tptime <= 4.5 and tptime > 4 then
tpicon:SetVertexColor(1, 1, 1)
end
if tptime <= 4 and tptime > 3.5 then
tpicon:SetVertexColor(1, 0, 0)
end
if tptime <= 3.5 and tptime > 3 then
tpicon:SetVertexColor(1, 1, 1)
end
if tptime <= 3 and tptime > 2.5 then
tpicon:SetVertexColor(1, 0, 0)
end
if tptime <= 2.5 and tptime > 2 then
tpicon:SetVertexColor(1, 1, 1)
end
if tptime <= 2 and tptime > 1.5 then
tpicon:SetVertexColor(1, 0, 0)
end
if tptime <= 1.5 and tptime > 1 then
tpicon:SetVertexColor(1, 1, 1)
end
if tptime <= 1 and tptime > 0.5 then
tpicon:SetVertexColor(1, 0, 0)
end
if tptime <= 0.5 and tptime > 0 then
tpicon:SetVertexColor(1, 1, 1)
end
else
tptext:SetText(string.sub(tptime, 1, 4))
end
end

function MonkHelper_ST()
local dummy1, dummy2, dummy3, dummy4, dummy5, duration, exptime, player = UnitBuff("player", "shuffle")
if exptime == nil then
MHstimer:Hide()
stime = 0
stext:SetText()
sicon:SetVertexColor(1, 0, 0)
else 
stime = (exptime - GetTime())
sicon:SetVertexColor(1, 1, 1)
MHstimer:Show()
end
end

function MonkHelper_TP()
local dummy1, dummy2, dummy3, dummy4, dummy5, duration, exptime, player = UnitBuff("player", "tiger power")
if exptime == nil then
MHtptimer:Hide()
tptime = 0
tptext:SetText()
tpicon:SetVertexColor(1, 0, 0)
else 
tptime = (exptime - GetTime())
tpicon:SetVertexColor(1, 1, 1)
MHtptimer:Show()
end
end

function MonkHelper_BT(aura)
bttime = 0
btcount = 0
btaura = aura
if btaura == "Tigereye Brew" or "Elusive Brew" then
for i = 1, 40 do  -- iterate through all buffs to work around the brew buff issue
name, dummy2, _texture, stack, dummy5, duration, exptime, player = UnitBuff("player", i)
if stack == nil and name == "Tigereye Brew" then
btcount = 0
else
btcount = stack
end
if name == btaura and duration > 20 and btcount > 0 then -- identifies the stacks by duration
MHbttimer:Show()
btctext:SetText(btcount)
bttime = (exptime - GetTime())
bticon:SetVertexColor(1, 1, 1)
elseif name == btaura and duration > 20 and btcount == 0 then
MHbttimer:Hide()
bttime = 0
bttext:SetText()
btctext:SetText()
bticon:SetVertexColor(1, 0, 0)
end
end
elseif btaura == "Mana Tea" then
name, dummy2, _texture, stack, dummy5, duration, exptime, player = UnitBuff("player", btaura)
if stack == nil then
btcount = 0
else
btcount = stack
end
if btcount > 0 then
MHbttimer:Show()
btctext:SetText(btcount)
bttime = (exptime - GetTime())
bticon:SetVertexColor(1, 1, 1)
else
MHbttimer:Hide()
bttime = 0
bttext:SetText()
btctext:SetText()
bticon:SetVertexColor(1, 0, 0)
end
end
end

function MonkHelper_Event(self, event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16)
if event == "ADDON_LOADED" and arg1 == "MonkHelper" then
if not MonkHelper_Options then -- First time running, initialize options
MonkHelper_Defaults()
end
MonkHelper_VarCheck()
MonkHelper_CreateUI()
MonkHelper_Config()
MonkHelper_UpdateUI()
self:UnregisterEvent("ADDON_LOADED")
elseif event == "UPDATE_SHAPESHIFT_FORM" then
_dummy1, MHresource = UnitPowerType("player")
if MHresource == "MANA" then
MHresourcebar:SetMinMaxValues(0, UnitPowerMax("player"))
MHresourcebar:SetStatusBarColor(0, 0, 1)
elseif MHresource == "ENERGY" then
MHresourcebar:SetMinMaxValues(0, UnitPowerMax("player"))
MHresourcebar:SetStatusBarColor(1, 1, 0)
end
MonkHelper_ResourceBarUpdate()
elseif event == "ACTIVE_TALENT_GROUP_CHANGED" then
MonkHelper_UpdateUI()
elseif event == "PLAYER_SPECIALIZATION_CHANGED" then 
MonkHelper_UpdateUI()
elseif event == "PLAYER_TALENT_UPDATE" then
MonkHelper_UpdateUI()
elseif event == "UNIT_POWER_FREQUENT" and arg1 == "player" and arg2 == "CHI" then
MonkHelper_ChiBarUpdate()
elseif event == "UNIT_POWER_FREQUENT" and arg1 == "player" and arg2 == MHresource then
MonkHelper_ResourceBarUpdate()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Rising Sun Kick" and arg15 == nil then 
delay = 0.1
trigger = arg13
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_CAST_SUCCESS" and arg5 == UnitName("player") and arg13 == "Flying Serpent Kick" then 
fsknorepeat = 0
MHfsktimer:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Tiger Power" then
MonkHelper_TP()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Blackout Kick" then
MonkHelper_ST()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Tigereye Brew" then
MonkHelper_BT(arg13)
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Fists of Fury" and arg15 == nil then 
delay = 0.1
trigger = arg13
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Renewing Mist" and arg15 == nil then
delay = 0.1
trigger = arg13
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_AURA_REMOVED" and arg5 == UnitName("player") and arg13 == "Thunder Focus Tea" then
tftdelay = 0.1
MHtftdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_CAST_SUCCESS" and arg5 == UnitName("player") and arg13 == "Mana Tea" and arg15 == nil then
btdelay, btaura = 0.1, arg13
MHbtdelay:Show()
MonkHelper_BT(arg13)
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Mana Tea" then
MonkHelper_BT(arg13)
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Keg Smash" and arg15 == nil then
delay = 0.1
trigger = arg13
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_CAST_SUCCESS" and arg5 == UnitName("player") and arg13 == "Elusive Brew" and arg15 == nil then
btdelay, btaura = 0.1, arg13
MHbtdelay:Show()
MonkHelper_BT(arg13)
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Elusive Brew" then
MonkHelper_BT(arg13)
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Guard" and arg15 == nil then 
delay = 0.1
trigger = arg13
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Detox" and arg15 == nil then 
delay = 1
trigger = arg13
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == "Expel Harm" and arg15 == nil then 
delay = 0.1
trigger = arg13
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg5 == UnitName("player") and arg13 == tier2 and arg15 == nil then
delay = 0.1
trigger = arg13
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_CAST_SUCCESS" and arg5 == UnitName("player") and arg13 == "Paralysis" then
delay = 0.5
trigger = arg13
pguid = arg8
pname = arg9
MHdelay:Show()
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_AURA_APPLIED" and arg5 == UnitName("player") and arg13 == "Paralysis" then
papplied = 1
pguid = arg8
pname = arg9
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_AURA_APPLIED_DOSE" and arg5 == UnitName("player") and arg13 == "Vital Mists" and arg16 == 5 then
if MonkHelper_Options.vitalmists == 1 then
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\surge.mp3", "SFX")
end
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_AURA_APPLIED" and arg5 == UnitName("player") and arg13 == "Combo Breaker: Tiger Palm" then
if MonkHelper_Options.cbtigerpalm == 1 then
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\tigergrowl.mp3", "SFX")
end
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_AURA_APPLIED" and arg5 == UnitName("player") and arg13 == "Combo Breaker: Blackout Kick" then
if MonkHelper_Options.cbblackoutkick == 1 then
PlaySoundFile("Interface\\AddOns\\MonkHelper\\Sounds\\stronghit.mp3", "SFX")
end
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_AURA_REFRESH" and arg5 == UnitName("player") and arg13 == "Paralysis" then
papplied = 1
pguid = arg8
pname = arg9
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_AURA_REMOVED"and arg8 == pguid and arg13 == "Paralysis" then
if papplied == 1 then
pdur = 0
pexpired = 1
MonkHelper_PMCombine(arg2, arg13)
pmdelay = 0.1
MHpmdelay:Show()
end
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and (arg2 == "SPELL_DAMAGE" or arg2 == "SWING_DAMAGE" or arg2 == "RANGE_DAMAGE" or arg2 == "SPELL_PERIODIC_DAMAGE")  and arg8 == pguid and papplied == 1 and pbreak == 0  then
pculprit = arg5
if pculprit == nil then
pculprit = "Unknown"
end
if arg5 == UnitName("player") then
if arg13 ~= "Expel Harm" and arg13 ~= "Chi Wave" and arg13 ~= "Chi Torpedo" and arg13 ~= "Chi Burst" and arg13 ~= "Zen Sphere" and arg13 ~= "Flying Serpent Kick" or arg13 == "Blackout Kick" then 
if arg2 ~= "SPELL_PERIODIC_DAMAGE" and arg13 == "Blackout Kick" then
pbreak = 1
elseif arg13 ~= "Blackout Kick" then
pbreak = 1
end
end
elseif arg5 ~= UnitName("player") then
pbreak = 1
end
pmarg2, pmarg13 = arg2, arg13
MonkHelper_PMCombine(pmarg2, pmarg13)
elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and arg2 == "SPELL_DAMAGE" and arg5 == UnitName("player") and arg13 == "Touch of Death" and (arg15 ~= nil or arg15 ~= 0 or arg15 ~= "ABSORB") then
if MonkHelper_Options.fatality == 1 then
fatalitydelay = 2.5
fatalitynorepeat = 0
MHfatalitytimer:Show()
end
elseif event == "UNIT_HEALTH" and arg1 == "player" then

elseif event == "PLAYER_REGEN_ENABLED" then
regen = true
MonkHelper_UpdateUI()
elseif event == "PLAYER_REGEN_DISABLED" then
regen = false
MonkHelper_UpdateUI()
end
end

------------------Update UI-----------------------------------------

function MonkHelper_UpdateUI()
_dummy1, MHresource = UnitPowerType("player")
MHchibar.mainframe:SetScale(MonkHelper_Options.chibarscale)
MHresourcebar:SetScale(MonkHelper_Options.resourcebarscale)
MonkHelper_UnlockFrames()
MonkHelper_ResourceBarUpdate()
rbtext:SetText(UnitPower("player"))
if UnitClass("player") == "Monk" then
if MHresource == "MANA" then
MHresourcebar:SetMinMaxValues(0, UnitPowerMax("player"))
MHresourcebar:SetStatusBarColor(0, 0, 1)
elseif MHresource == "ENERGY" then
MHresourcebar:SetMinMaxValues(0, UnitPowerMax("player"))
MHresourcebar:SetStatusBarColor(1, 1, 0)
end
MonkHelper_Hide()
MonkHelper_Show(MHchibar.mainframe, MonkHelper_Options.show.MHchibar)
MonkHelper_Show(MHresourcebar, MonkHelper_Options.show.MHresourcebar)
MonkHelper_Show(MHtigerpower, MonkHelper_Options.show.MHtigerpower)
MonkHelper_Show(MHbrewtracker, MonkHelper_Options.show.MHbrewtracker)
MonkHelper_Show(MHexpelharm, MonkHelper_Options.show.MHexpelharm)
MonkHelper_Show(MHdetox, MonkHelper_Options.show.MHdetox)
local t21, t22, t23 = 0, 0, 0
for i=4, 6 do
local name, texture, _dummy3, _dummy4, learned = GetTalentInfo(i)
if learned == true then
t2icon:SetTexture(texture)
tier2 = name
end
if i == 4 then
t21 = learned
elseif i == 5 then
t22 = learned
elseif i == 6 then 
t23 = learned
end
end
if t21 or t22 or t23 == true then
MonkHelper_Show(MHtier2, MonkHelper_Options.show.MHtier2)
else
MHtier2:Hide()
end
if UnitPowerMax("player", 12) == 5 then
MHchibar.texture0[5]:Show()
else
MHchibar.texture0[5]:Hide()
end
if GetSpecialization() == 1 then -- Brewmaster
bticon:SetTexture("Interface\\Icons\\spell_brew_wheat")
MonkHelper_Show(MHkegsmash, MonkHelper_Options.show.MHkegsmash)
MonkHelper_Show(MHguard, MonkHelper_Options.show.MHguard)
MonkHelper_Show(MHshuffle, MonkHelper_Options.show.MHshuffle)
elseif GetSpecialization() == 2 then -- Mistweaver
bticon:SetTexture("Interface\\Icons\\inv_misc_herb_jadetealeaf")
MonkHelper_Show(MHrenewingmist, MonkHelper_Options.show.MHrenewingmist)
MonkHelper_Show(MHthunderfocustea, MonkHelper_Options.show.MHthunderfocustea)
elseif GetSpecialization() == 3 then -- Windwalker
bticon:SetTexture("Interface\\Icons\\spell_brew_dark")
MonkHelper_Show(MHflyingserpentkick, MonkHelper_Options.show.MHflyingserpentkick)
MonkHelper_Show(MHrisingsunkick, MonkHelper_Options.show.MHrisingsunkick)
MonkHelper_Show(MHfistsoffury, MonkHelper_Options.show.MHfistsoffury)
else
MonkHelper_Hide()
end
if regen == true then
MonkHelper_UnlockFrames()
if MonkHelper_Options.hideframes == 1 then
MonkHelper_Hide()
end
elseif regen == false then
MonkHelper_LockFrames()
end
if MonkHelper_Options.pmautohide == 1 then -- Paralysis Monitor auto hide
MHparalysis:Hide()
elseif MonkHelper_Options.pmautohide == 0 and MonkHelper_Options.hideframes == 0 then
MHparalysis:Show()
elseif MonkHelper_Options.pmautohide == 0 and MonkHelper_Options.hideframes == 1 then
if regen == true then
MHparalysis:Hide()
elseif regen == false then
MHparalysis:Show()
end
end
else -- Not a monk, hide everything
MonkHelper_Hide()
end
end

-------------------Set Scripts------------------------
MHeventframe:SetScript("OnEvent", MonkHelper_Event)
MHbtdelay:SetScript("OnUpdate", MonkHelper_BTDelay)
MHbttimer:SetScript("OnUpdate", MonkHelper_BTTimer)
MHpduration:SetScript("OnUpdate", MonkHelper_PDuration)
MHdelay:SetScript("OnUpdate", MonkHelper_Delay)
MHtftdelay:SetScript("OnUpdate", MonkHelper_TFTDelay)
MHtptimer:SetScript("OnUpdate", MonkHelper_TPTimer)
MHdetoxcheck:SetScript("OnUpdate", MonkHelper_DetoxCheck)
MHpmdelay:SetScript("OnUpdate", MonkHelper_PMDelay)
MHfsktimer:SetScript("OnUpdate", MonkHelper_FSKTimer)
MHfatalitytimer:SetScript("OnUpdate", MonkHelper_FatalityTimer)
MHstimer:SetScript("OnUpdate", MonkHelper_ShuffleTimer)
-----------------------------------------------------------
end





